"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }// src/list-helpers.ts
function getListItemSpacing(tokenIndex, tokens) {
  const token = tokens[tokenIndex];
  if (!token || token.type !== "list_item_open") {
    return "thin";
  }
  let closeIndex = tokenIndex;
  const baseLevel = token.level;
  for (let i = tokenIndex + 1; i < tokens.length; i++) {
    if (tokens[i] && _optionalChain([tokens, 'access', _ => _[i], 'optionalAccess', _2 => _2.type]) === "list_item_close" && _optionalChain([tokens, 'access', _3 => _3[i], 'optionalAccess', _4 => _4.level]) === baseLevel) {
      closeIndex = i;
      break;
    }
  }
  const children = [];
  for (let i = tokenIndex + 1; i < closeIndex; i++) {
    if (tokens[i] && _optionalChain([tokens, 'access', _5 => _5[i], 'optionalAccess', _6 => _6.level]) === baseLevel + 1 && _optionalChain([tokens, 'access', _7 => _7[i], 'optionalAccess', _8 => _8.map]) && _optionalChain([tokens, 'access', _9 => _9[i], 'optionalAccess', _10 => _10.type, 'access', _11 => _11.endsWith, 'call', _12 => _12("_open")])) {
      children.push(tokens[i]);
    }
  }
  if (children.length > 1) {
    return "thick";
  }
  if (children.length === 1 && token.map) {
    const child = children[0];
    if (!child) {
      return "thin";
    }
    if (!child.map) {
      return "thin";
    }
    const itemStart = token.map[0];
    const itemEnd = token.map[1];
    const childStart = child.map[0];
    const childEnd = child.map[1];
    let isFirst = true;
    let isLast = true;
    for (let i = tokenIndex - 1; i >= 0; i--) {
      const currentToken = tokens[i];
      if (currentToken && currentToken.type === "list_item_open" && currentToken.level === baseLevel) {
        isFirst = false;
        break;
      }
      if (currentToken && currentToken.level < baseLevel) break;
    }
    for (let i = closeIndex + 1; i < tokens.length; i++) {
      const currentToken = tokens[i];
      if (currentToken && currentToken.type === "list_item_open" && currentToken.level === baseLevel) {
        isLast = false;
        break;
      }
      if (currentToken && currentToken.level < baseLevel) break;
    }
    if (!isFirst && isLast) {
      if (childStart - itemStart >= 1) {
        return "thick";
      }
    } else if (isFirst && !isLast) {
      if (itemEnd - childEnd >= 1) {
        return "thick";
      }
    } else if (!isFirst && !isLast) {
      if (childStart - itemStart >= 1 || itemEnd - childEnd >= 1) {
        return "thick";
      }
    }
  }
  return "thin";
}


exports.getListItemSpacing = getListItemSpacing;
