import { PluginWithOptions } from 'markdown-it';

/**
 * This plugin customizes how bullet, ordered, and task lists are parsed
 * and rendered. It detects todo/task items (by looking for a leading
 * "[ ] ", "[x] ", or "[X] ") in list items after inline processing,
 * then marks those list items with data-bangle-list-kind="task" and
 * data-bangle-task-checked accordingly.
 *
 * The plugin also assigns list kinds for bullet and ordered lists,
 * and numbers ordered list items using an order stack.
 */
type ListMarkdownPluginOptions = Record<string, never>;
declare const listMarkdownPlugin: PluginWithOptions<ListMarkdownPluginOptions>;

export { type ListMarkdownPluginOptions, listMarkdownPlugin };
